config/routes.rb
Rails.application.routes.draw do
  get 'order_items/show'
  get 'checkouts/index'
  resources :order_items
  resources :cart
  devise_for :users, :controllers => { registrations: 'registrations'}
  resources :admins
  resources :users
  resources :products
  resources :vendors
  resources :orders
  root to: "home#index"
  get 'home/index'
  post "checkout/create", to: "checkout#create"
  post "products/add_to_cart/:id", to: "products#add_to_cart", as: "add_to_cart"
  delete "products/remove_from_cart/:id", to: "products#remove_from_cart", as: "remove_from_cart"
  # resources :webhooks, only: [:create]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/order.rb
class Order < ApplicationRecord
  has_many :order_items, dependent: :destroy
  has_one :user
end

app/models/order_item.rb
class OrderItem < ApplicationRecord
	belongs_to :order
	belongs_to :product
end

app/models/product.rb
class Product < ApplicationRecord
  belongs_to :user

  has_many_attached :images

  has_many :order_items
end

app/models/role.rb
class Role < ApplicationRecord
  has_and_belongs_to_many :users, :join_table => :users_roles
  
  belongs_to :resource,
             :polymorphic => true,
             :optional => true
  

  validates :resource_type,
            :inclusion => { :in => Rolify.resource_types },
            :allow_nil => true

  scopify
end

app/models/user.rb
class User < ApplicationRecord
  has_many :products, :dependent => :destroy
  has_many :order
  
  rolify
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :trackable
  
  after_create :assign_default_role

  validate :must_have_a_role, on: :update

  validate :must_have_a_role, on: :new

  after_create do 
    customer = Stripe::Customer.create(email: email)
    update(stripe_customer_id: customer.id)
  end

  private

  def must_have_a_role
    unless roles.any?
      errors.add(:roles, "Must have at least 1 role")
    end
  end

  def assign_default_role
    self.add_role(:User) if self.roles.blank?
  end

end

app/controllers/cart_controller.rb
class CartController < ApplicationController
  def index
    # if session[:cart]
    #   @products = Product.where(id: session[:cart])
    # end
  end 
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  # before_action :confirm_role
  def index
    if current_user.has_role? :Admin
        redirect_to admins_path
    elsif current_user.has_role? :Vendor
        redirect_to vendors_path
    else
      @products=Product.all
    end
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def update
    @user = User.find(params[:id])
    if @user.update(user_params)
        redirect_to admins_path, notice: "User successfly updated."
    else
        render :edit
    end
  end

  private
  def user_params
    params.require(:user).permit({role_ids: []})
  end
end

app/helpers/admins_helper.rb
module AdminsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cart_helper.rb
module CartHelper
end

app/helpers/checkouts_helper.rb
module CheckoutsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/order_items_helper.rb
module OrderItemsHelper
end

app/helpers/orders_helper.rb
module OrdersHelper
end

app/helpers/product_helper.rb
module ProductHelper
end

app/helpers/registrations_helper.rb
module RegistrationsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/vendors_helper.rb
module VendorsHelper
end

app/views/admins/edit.html.erb
<%= form_with(model: @user) do |form| %>
    <%= form.collection_check_boxes :role_ids, Role.all, :id, :name %>
    <%= @user.errors[:roles] %>
    <%= form.button :submit %>
<% end %> 

app/views/admins/index.html.erb
<div class="container p-3">
  <div class="row">
    <div class="col">
      <h2>Vendor</h2>
    </div>
  </div>  
  <div class="table-responsive">
    <table class="table table-striped">
      <tr class="header text-center">
        <th>Name</th>
        <th>Email</th>
        <th>Products</th>
        <th>Actions</th>
      </tr>
      <% @users.each do |user| %>
        <% if user.has_role? :Vendor %>
          <tr class="<%= cycle('odd', 'even') %> text-center">
            <td><%= user.username %></td>
            <td><%= user.email %></td>
            <td class="center"><%= user.products.size %></td>
            <td>
              <div class="row">
                <div class="col">
                  <%= link_to "View Products", products_path(:id=>user.id) %>
                  <%= link_to "Show", admin_path(:id=>user.id) %>
                  <%= link_to "Edit", edit_admin_path(:id => user.id) %>
                  <%= link_to "Destroy", admin_path(user.id),
                        method: :delete,
                        data: { confirm: "Are you sure?" } %>          
                </div>
              </div>  
            </td>
          </tr>
        <% end %>
      <% end %>
    </table>
  </div>
  <div class="row">
    <div class="col">
      <h2>User</h2>
    </div>
  </div>  
  <div class="table-responsive">
    <table class="table table-striped">
      <tr class="header text-center">
        <th>Name</th>
        <th>Email</th>
        <th>Actions</th>
      </tr>
      <% @users.each do |user| %>
        <% if user.has_role? :User %>
          <tr class="<%= cycle('odd', 'even') %> text-center">
            <td><%= user.username %></td>
            <td><%= user.email %></td>
            <td>
              <div class="row">
                <div class="col">
                  <%= link_to "Show", admin_path(:id=>user.id) %>
                  <%= link_to "Edit", edit_admin_path(:id => user.id) %>
                  <%= link_to "Destroy", admin_path(user.id),
                        method: :delete,
                        data: { confirm: "Are you sure?" } %>          
                </div>
              </div>  
            </td>
          </tr>
        <% end %>
      <% end %>
    </table>
  </div>
</div>

app/views/admins/show.html.erb
<% @page_title = "Show User" %>

<div class="container">
  <div class="row">
    <div class="col">
      <%= link_to "<< Back to List", admins_path %>
    </div>
    <div class="col-8">
      <h2>Show User</h2>
    </div>
  </div> 
  <div class="table-responsive">
    <table class="table table-striped">
      <tr>
        <th>Name</th>
        <td><%= @user.username %></td>
      </tr>
      <tr>
          <th>Email</th>
          <td><%= @user.email %></td>
      </tr>
      <tr>
        <th>Created</th>
        <td><%= @user.created_at %></td>
      </tr>
      <tr>
        <th>Updated</th>
        <td><%= @user.updated_at %></td>
      </tr>
    </table>
  </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Shop</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <script src="https://js.stripe.com/v3/"></script>
    <script src="https://code.jquery.com/jquery-3.6.0.js" integrity="sha256-H+K7U5CnXl1h5ywQfKtSj8PCmoN9aaq30gDh27Xc0jk=" crossorigin="anonymous"></script>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="https://pro.fontawesome.com/releases/v5.10.0/css/all.css" integrity="sha384-AYmEC3Yw5cVb3ZcuHtOA93w35dYTsvhLPVnYs9eStHfGJvOvKxVfELGroGkvsg+p" crossorigin="anonymous"/>    
  </head>

  <body>
    <% if user_signed_in? %>
      <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
          <a class="navbar-brand" href="/">Shop</a>
          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarNav">
            <% if (current_user.has_role? :Admin) || (current_user.has_role? :Vendor) %>
            <ul class="navbar-nav ml-auto">
              <li class="nav-item">
                <div class="nav-link">
                  <% if current_user.has_role? :Admin %>
                    <%= link_to 'Dashboard', admins_path%>
                  <% else %>
                    <%= link_to 'Dashboard', vendors_path%>
                  <% end %>
                </div>
              </li>
              <li class="nav-item">
                <div class="nav-link">
                  <%= link_to 'Order', orders_path%>
                </div>
              </li>
              <li class="nav-item">
                <div class="nav-link">
                  <% if current_user.has_role? :Vendor %>
                    <%= link_to 'Products', products_path(:id=>current_user.id)%>
                  <% end %>
                </div>
              </li>
            </ul>
            <% end %>
            <ul class="navbar-nav ml-auto">
              <li class="nav-item">
                <div class="nav-link">
                  <%= link_to 'log out', destroy_user_session_url, method: :delete , id:"logout"%>
                </div>
              </li>
              <li class="nav-item">
                <div class="nav-link">
                  <%= link_to 'Profile', edit_user_registration_path %>
                </div>
              </li>
            </ul>
          </div>
        </div>
      </nav>
      <% if (current_user.has_role? :Admin) || (current_user.has_role? :Vendor) %>
        <main class="container p-3">
          <p class="notice"><%= notice %></p>
          <p class="alert"><%= alert %></p>
          <%= yield %>
        </main>
      <% end %>
      <% if current_user.has_role? :User %>
        <%= yield %>
      <% end %> 
    <% else %>
      <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
          <a class="navbar-brand" href="/">Shop</a>
          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav ml-auto">
              <li class="nav-item">
                <div class="nav-link">
                  <%= link_to 'log in', new_user_session_path %>
                </div>
              </li>
              <li class="nav-item">
                <div class="nav-link">
                  <%= link_to 'Sign up ', new_user_registration_path, :id => "ppp" %>
                </div>
              </li>
            </ul>
          </div>
        </div>
      </nav>
      <br>
      <%= yield %>
    <% end %> 
  </body>
</html> 